#include "omp.h"
#include <stdio.h>

//only define one of these two
//#define USE_OMP
//#define USE_OMP_REDUCE

#define STEPS 100000000
#define TRIES 1

int main(int argc, char *argv[]){

double x, sum, pi, step,aux;
int tries,i,num_steps = STEPS;

for(tries = 0;tries < TRIES; tries++){

#ifdef USE_OMP

    x=0;
    sum = 0.0;
    step = 1.0/(double) num_steps;
 #pragma omp parallel private(i,x,aux) shared(sum) 
   {
 #pragma omp for schedule(static) 
      for (i=0; i<num_steps; i=i+1){

         x=(i+0.5)*step;
         aux=4.0/(1.0+x*x);
 //#pragma omp critical
   //      sum = sum + aux;
      }
     #pragma omp critical
         sum = sum + aux;
   }
   pi=step*sum;
#elif defined(USE_OMP_REDUCE) //internal OpenMP reduction construct
    x=0;
    sum = 0.0;
    step = 1.0/(double) num_steps;
 #pragma omp parallel private(i,x) 
   {
 #pragma omp for reduction(+:sum) schedule(static)
      for (i=0; i<num_steps; i=i+1){
         x=(i+0.5)*step;
         sum = sum + 4.0/(1.0+x*x);
      }
   }
   pi=step*sum;

#else  //sequential 

    x=0;
    sum = 0.0;
    step = 1.0/(double) num_steps;
    for (i=0; i < num_steps; ++i) {
        x = (i+0.5)*step;
        sum = sum + 4.0/(1.0+x*x);
    }
    pi = step * sum;

#endif
}

printf("The calculated PI value: %f\n",pi);
}


